
package rossi.Pop;

import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

/** Abstract class representing a single mail message.  This is to
    be extended by implemetors of MailFactory objects to contain
    MailFactory specific information.  The fields defined in this
    class are used by user code for manipulating the message */

public abstract class MailSpec
{
  /** The size of this message -- including CRLF line termination */ 
  public long Size; 

  /** A unique identifier for this message */
  public String UniqID;

  /** True if message should be deleted upon call to 
      MailFactory.updateMaildrop() */
  boolean Delete;

  /** Read prior to this session */
  boolean ReadPreviously;

  /** Read prior to OR during this session */
  boolean Read;
}
