
package rossi.Pop;

import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class OS2MailFactory implements MailFactory
{
  OS2MailSpec MailSpecs[];
  Properties DefaultProperties;
  File Dir;

  public OS2MailFactory()
  {
    DefaultProperties = new Properties();
  }

  public boolean setMailbox(String Path)
  {
    OS2MailSpec Spec;
    String DirList[];
    String Extension;
    File MailFile;
    StringTokenizer st;
    int i;

    /* Get a file object for the directory containing the mail */
    Dir = new File(Path);

    /* List the directory */
    
    DirList = Dir.list();
    
    if (DirList != null)
    {
      MailSpecs = new OS2MailSpec[DirList.length];

      for (i=0; i<DirList.length; i++)
      {
        Spec = new OS2MailSpec();
        MailFile = new File(Dir, DirList[i]);

        st = new StringTokenizer(DirList[i], ".");
        Spec.Location = DirList[i];
        Spec.Size = MailFile.length();
        Spec.TimeStamp = MailFile.lastModified();
        Spec.Delete = false;
        Spec.UniqID = st.nextToken();
        Extension = st.nextToken();
        if (Extension.equals("MA_"))
        {
          Spec.ReadPreviously = false;
//          System.err.println("Message "+DirList[i]+" not previously read  Extension = \""+Extension+"\"");
        }
        else
        {
          Spec.ReadPreviously = true;
        }
        Spec.Read = Spec.ReadPreviously;
        MailSpecs[i] = Spec;
      }
    } 
    if (DirList.length != 0)
      QsortMailSpecs(0, DirList.length-1);

    return true;
  }

  private void QsortMailSpecs(int FirstItem, int LastItem)
  {
    OS2MailSpec Tmp, PivotValue;
    int pivot, Position, i;


    if ((LastItem - FirstItem) == 1)
    {
      if (MailSpecs[LastItem].TimeStamp < MailSpecs[FirstItem].TimeStamp)
      {
        Tmp = MailSpecs[FirstItem];
	MailSpecs[FirstItem] = MailSpecs[LastItem];
        MailSpecs[LastItem] = Tmp;
      }
      return;
    }
    
    pivot = (FirstItem + LastItem) / 2;
    PivotValue = MailSpecs[pivot];

    Position = FirstItem;

    if (MailSpecs[Position].TimeStamp > PivotValue.TimeStamp)
    {
      Tmp = MailSpecs[Position];
      MailSpecs[Position] = MailSpecs[pivot];
      MailSpecs[pivot] = Tmp;
      Position = Position + 1;
    }

    for (i=FirstItem; i<=LastItem; i++)
    {
      if (MailSpecs[i].TimeStamp < PivotValue.TimeStamp)
      {
        Tmp = MailSpecs[Position];
        MailSpecs[Position] = MailSpecs[i];
        MailSpecs[i] = Tmp;
        Position++;
      }    
    }

    if (Position == FirstItem)
      Position++;

    if (FirstItem < (Position-1))
      QsortMailSpecs(FirstItem, Position-1);

    if ((Position) < LastItem)
      QsortMailSpecs(Position, LastItem);

  }  

  /* Returns a vector containing a bunch of MailSpec objects */
  public MailSpec[] getMailList()
  {
    return MailSpecs;
  }

  /* Returns an InputStream for reading actual message data */
  public InputStream getMessageInputStream(int MsgNum)
  {
    InputStream in = null;

    File f = new File(Dir, MailSpecs[MsgNum].Location);
    try 
    {
      in =  new FileInputStream(f);
    }
    catch (FileNotFoundException e)
    {
    }
    return in;
  }

  private boolean deleteMessage(int MsgNum)
  {
    File f = new File(Dir, MailSpecs[MsgNum].Location);
    return f.delete();
  }
 
  public void updateMaildrop()
  {
    int i;

    for (i=0; i<MailSpecs.length; i++)
    {
      if (MailSpecs[i].Delete)
      {
        deleteMessage(i);
      }
      else
      {
        if (MailSpecs[i].Read)
        {
          File f = new File(Dir, MailSpecs[i].Location);
          f.renameTo(new File(Dir, MailSpecs[i].UniqID+".MA-"));
        }
      }
    }
  }

  public void setProperties(Properties p)
  {
  }

  public String[] listPropertyNames()
  {
    return new String[0];
  }

  public String checkProperties()
  {
    return null;
  }

  public Properties getDefaultProperties()
  {
    return DefaultProperties;
  }
}
