
package rossi.Pop;

import java.awt.*;
import java.lang.*;
import java.util.*;
import java.io.*;

class SetupYesNoDialog extends Frame
{
  Button YesButton, NoButton, CancelButton;
  boolean Answer, Canceled;
  boolean Disposed = false;
  Frame Parent;

  SetupYesNoDialog(Frame Parent, String Text, boolean HaveCancel)
  {
    //super(Parent, true);

    this.Parent = Parent;
    Panel ButtonPanel;
    Label TextLabel;

    setLayout(new BorderLayout(20,20)); 
    TextLabel = new Label(Text);
    TextLabel.setFont(new Font("TimesRoman", Font.BOLD, 24));
    add("North", TextLabel);
 
    ButtonPanel = new Panel();
    add("South", ButtonPanel);

    ButtonPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
    YesButton = new Button("Yes");
    NoButton = new Button("No");
    if (HaveCancel)
      CancelButton = new Button("Cancel");
    ButtonPanel.add(YesButton);
    ButtonPanel.add(NoButton);
    if (HaveCancel)
      ButtonPanel.add(CancelButton);
  }
 
  public synchronized void show() 
  {
    Rectangle bounds = Parent.bounds();
    Rectangle abounds = bounds();

    move(bounds.x + (bounds.width - abounds.width)/ 2,
         bounds.y + (bounds.height - abounds.height)/2);

    super.show();
  }


  public boolean action(Event e, Object arg)
  {
    Event evt = null;
    Component Parent = this.Parent;


    if (e.target == YesButton)
    {
      evt = new Event(this, Event.ACTION_EVENT, "Yes");
      Answer = true;
      Canceled = false;
    }

    if (e.target == NoButton)
    {
      evt = new Event(this, Event.ACTION_EVENT, "No");
      Answer = false;
      Canceled = false;
    }

    if (e.target == CancelButton)
    {
      evt = new Event(this, Event.ACTION_EVENT, "Cancel");
      Answer = false;
      Canceled = true;
    }

    if (evt != null)
    {
      while(Parent.handleEvent(evt) == false)
      {
	Parent = Parent.getParent();
	if (Parent == null)
	  return false;
      } 
      hide();
      dispose();
      Disposed = true;
      return true;
    }
    return false;
  }
}

class SetupErrorDialog extends Frame
{
  Button YesButton;
  boolean Answer;
  boolean Disposed = false;
  Frame Parent;

  SetupErrorDialog(Frame Parent, String Text)
  {
    //super(Parent, true);

    Panel ButtonPanel;
    Label TextLabel;

    setTitle(Text);
    setLayout(new BorderLayout(20,20)); 
    TextLabel = new Label(Text);
    TextLabel.setFont(new Font("TimesRoman", Font.BOLD, 24));
    add("North", TextLabel);
 
    ButtonPanel = new Panel();
    add("South", ButtonPanel);

    ButtonPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
    YesButton = new Button("Ok");
    ButtonPanel.add(YesButton);
    this.Parent = Parent;
    pack();
    show();
  }
 
  public synchronized void show() 
  {
    Rectangle bounds = Parent.bounds();
    Rectangle abounds = bounds();

    move(bounds.x + (bounds.width - abounds.width)/ 2,
         bounds.y + (bounds.height - abounds.height)/2);

    super.show();
  }


  public boolean action(Event e, Object arg)
  {
    if (e.target == YesButton)
    {
      hide();
      dispose();
      Disposed = true;
      return true;
    }

    return false;
  }
}

class SetupAboutBox extends Frame
{
  Frame Parent;
  boolean Disposed = false;

  SetupAboutBox(Frame Parent)
  {
//    super(Parent, true); 
    this.Parent = Parent;
    setBackground(Color.black);
    setTitle("About");
    calcsize();
    show();
  }

  /* Size the window */
  private void calcsize()
  {
    int i, x, y;
    Toolkit t;
    Font f;
    FontMetrics Fm;
    String str;
    
    t = getToolkit();
    f = new Font("TimesRoman", Font.BOLD, 24);
    Fm = t.getFontMetrics(f);
    
    str = "J-POP Server ver. "+Server.Version;
    x = Fm.stringWidth(str);

    f = new Font("TimesRoman", Font.PLAIN, 14);
    Fm = t.getFontMetrics(f);
    y = 5 * 4 * (Fm.getMaxAscent() + Fm.getMaxDecent());

    resize (x*11/10, y*11/10);
  }

  public void paint(Graphics g)
  {
    int i, y;
    Rectangle r;
    Toolkit t;
    Font f;
    FontMetrics Fm;
    String str;
    Insets ins;
    
    ins = insets();
    r = bounds();

    g.setColor(Color.gray);
    for (i=0; i<10; i++) 
      g.drawLine(0, i*(r.height/10), r.width, i*(r.height/10));
    for (i=0; i<10; i++) 
      g.drawLine(i*(r.width/10), 0, i*(r.width/10), r.height);
    g.setColor(Color.green);
    g.drawLine(0, 4*(r.height/10), 2*(r.width/10)-1, 4*(r.height/10));
    g.drawLine(2*(r.width/10)+1, 6*(r.height/10), r.width, 6*(r.height/10));
    g.drawLine(2*(r.width/10)-1, 4*(r.height/10), 2*(r.width/10)+1, 6*(r.height/10));
    g.drawLine(4*(r.width/10)+1, 4*(r.height/10), r.width, 4*(r.height/10));
    g.drawLine(4*(r.width/10)+1, 4*(r.height/10), 4*(r.width/10)-1, 6*(r.height/10));
    g.drawLine(6*(r.width/10)+1, 4*(r.height/10), 6*(r.width/10)-1, 6*(r.height/10));
    g.drawLine(8*(r.width/10)+1, 4*(r.height/10), 8*(r.width/10)-1, 6*(r.height/10));

    t = getToolkit();
    f = new Font("TimesRoman", Font.BOLD, 24);
    Fm = t.getFontMetrics(f);
    g.setFont(f);
    y = ins.top;
    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    str = "Rossi Engineering";
    g.drawString(str,  (r.width - Fm.stringWidth(str))/2, y);

    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    str = "J-POP Server ver. "+Server.Version;
    g.drawString(str,  (r.width - Fm.stringWidth(str))/2, y);

    f = new Font("TimesRoman", Font.PLAIN, 14);
    Fm = t.getFontMetrics(f);
    g.setFont(f);
    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    str = "(C) 1997 Rossi Engineering";
    g.drawString(str,  (r.width - Fm.stringWidth(str))/2, y);

    if (y < 7*(r.height/10) + Fm.getMaxAscent() + Fm.getMaxDecent())
      y = 7*(r.height/10) + Fm.getMaxAscent() + Fm.getMaxDecent();
    else
      y = y + Fm.getMaxAscent() + Fm.getMaxDecent();

    str = "Build # "+BuildVer.Version+"  Date "+BuildVer.BuildDate+"  Time "+BuildVer.BuildTime;
    g.drawString(str,  ins.left, y);

    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    g.drawString("Java Version: "+System.getProperty("java.version"), ins.left, y);
    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    g.drawString("Java Class ver: "+System.getProperty("java.class.version"), ins.left, y);
    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    g.drawString("Java Vendor: "+System.getProperty("java.vendor"), ins.left, y);
    y = y + Fm.getMaxAscent() + Fm.getMaxDecent();
    g.drawString("OS: "+System.getProperty("os.name")+" "+
                        System.getProperty("os.version")+" "+
                        System.getProperty("os.arch"), ins.left, y);

  }

  public synchronized void show() 
  {
    Rectangle bounds = Parent.bounds();
    Rectangle abounds = bounds();

    move(bounds.x + (bounds.width - abounds.width)/ 2,
         bounds.y + (bounds.height - abounds.height)/2);

    super.show();
  }

  public boolean mouseUp(Event e, int x, int y)
  {
    hide();
    dispose();
    Disposed = true;
    return true;
  }

  public boolean KeyUp(Event e, int k)
  {
    hide();
    dispose();
    Disposed = true;
    return true;
  }

  public boolean handleEvent(Event e)
  {
    if (e.id == Event.KEY_RELEASE || e.id == Event.WINDOW_DESTROY)
    {
      hide();
      dispose();
      Disposed = true;
      return true;
    }
    
    return super.handleEvent(e);
  }
}

public class Setup extends Frame
{
  File PropFile;
  List UserList, TcpdList;
  Configuration Config;
  Panel UserRightButtonPanel;
  Panel UserBottomPanel;
  Panel TcpdRightButtonPanel;
  Panel TcpdBottomPanel;
  TextField UserNameText, PasswordText, MbxDirText;
  CardLayout Cards;
  Panel UserPanel, ServerProfilePanel, TcpdPanel;
  Panel MailFactoryPanel, MailFactoryOptionsTopPanel;
  MenuBar SetupMenuBar;
  Menu ConfigureMenu;
  Menu FileMenu;
  Menu HelpMenu;
  MenuItem UsersMenuItem;
  MenuItem ProfileMenuItem;
  MenuItem TcpdMenuItem;
  MenuItem MailFactoryMenuItem;
  MenuItem SaveMenuItem;
  MenuItem ExitMenuItem;
  MenuItem AboutMenuItem;
  Button UserAddButton, UserModifyButton, UserDeleteButton;
  Button TcpdAddButton, TcpdModifyButton, TcpdDeleteButton;
  SetupYesNoDialog AddCreateDir = null, ModifyCreateDir = null;
  SetupYesNoDialog SaveChangesYesNo = null, SaveBeforeSwitch = null;
  SetupYesNoDialog UserDeleteConfirm = null, NetworkDeleteConfirm = null;
  SetupAboutBox AboutBox = null;
  boolean ConfigChangesMade = false;
  boolean ProfileChangesMade = false;
  TextField UserListFnameText;
  TextField LogFnameText;
  TextField TcpdFnameText;
  TextField RegNameText;
  TextField RegKeyText;
  TextField MailFactoryText;
  TextField[] MailFactoryOptionsText; 
  TextField TcpdNetworkText, TcpdNetMaskText, TcpdCommentText;
  Vector TcpdAddr, TcpdMask, TcpdComment;
  Checkbox RestrictAccess, EnableLAST, EnableUIDL;
  Checkbox EnableTOP, EnableAPOP, EnableUSERPASS;
  TextField HostNameText;
  Button ProfileApplyButton, MailFactoryApplyButton;
  Properties ServerProps;
  String NextPanel = null;

  Setup()
  {

    /* Get the properties */
    PropFile = Server.LoadProperties();


    setBackground(Color.lightGray);

    Cards = new CardLayout();
    this.setLayout(Cards);
    UserPanel = new Panel();
    ServerProfilePanel = new Panel();
    TcpdPanel = new Panel();
    MailFactoryPanel = new Panel();
    add("User", UserPanel);
    add("Profile", ServerProfilePanel);
    add("Tcpd", TcpdPanel);
    add("MailFactory", MailFactoryPanel);

    Cards.show(this, "User");

    SetupUserPanel();
    SetupProfilePanel();
    SetupTcpdPanel();
    SetupMailFactoryPanel();

    /* Load the profile panel first since  */
    /* It loads the properties need by the */
    /* other panels.                       */

    LoadProfilePanel();
    LoadUserList();
    LoadTcpdPanel();

    /* Setup the menus */
    
    SetupMenuBar = new MenuBar();
    setMenuBar(SetupMenuBar);
    
    FileMenu = new Menu("File");
    SetupMenuBar.add(FileMenu);
    SaveMenuItem = new MenuItem("Save Changes");
    ExitMenuItem = new MenuItem("Exit");
    FileMenu.add(SaveMenuItem);
    FileMenu.add(ExitMenuItem);

    ConfigureMenu = new Menu("Configure");
    SetupMenuBar.add(ConfigureMenu);
    UsersMenuItem = new MenuItem("Users");
    ProfileMenuItem = new MenuItem("Server Profile");
    TcpdMenuItem = new MenuItem("Allowed Hosts");
    MailFactoryMenuItem = new MenuItem("MailFactory options");

    if (ServerProps.getProperty("rossi.Pop.UseTcpd").equals("true") == false)
      TcpdMenuItem.disable();

    setMailFactoryMenuItemState();

    ConfigureMenu.add(UsersMenuItem);
    ConfigureMenu.add(ProfileMenuItem);
    ConfigureMenu.add(TcpdMenuItem);
    ConfigureMenu.add(MailFactoryMenuItem);

    HelpMenu = new Menu("Help");
    SetupMenuBar.setHelpMenu(HelpMenu);
    AboutMenuItem = new MenuItem("About");
    HelpMenu.add(AboutMenuItem);

    if (Config.UserList.size() == 0)
      Cards.show(this, "Profile");

    setTitle("Rossi Engineering's J-POP Server");
    pack();
    show(); 
    UserList.requestFocus();
  }

  private void SetupUserPanel()
  {
    Label UserLabel;

    UserPanel.setLayout(new BorderLayout(20,5));
    UserLabel = new Label("User Name");
    UserLabel.setAlignment(Label.LEFT);
    UserPanel.add("North", UserLabel);
    UserList = new List(10, false);
    UserList.setBackground(Color.white);
    UserPanel.add("Center", UserList);
    UserRightButtonPanel = new Panel();
    UserPanel.add("East", UserRightButtonPanel);
    SetupUserRightButtonPanel();
    UserBottomPanel = new Panel();
    UserPanel.add("South", UserBottomPanel);
    SetupUserBottomPanel();
  }

  private void SetupTcpdPanel()
  {
    Label TcpdLabel;

    TcpdPanel.setLayout(new BorderLayout(20,5));
    TcpdLabel = new Label("Allowed Hosts");
    TcpdLabel.setAlignment(Label.LEFT);
    TcpdPanel.add("North", TcpdLabel);
    TcpdList = new List(10, false);
    TcpdList.setBackground(Color.white);
    TcpdPanel.add("Center", TcpdList);
    TcpdRightButtonPanel = new Panel();
    TcpdPanel.add("East", TcpdRightButtonPanel);
    SetupTcpdRightButtonPanel();
    TcpdBottomPanel = new Panel();
    TcpdPanel.add("South", TcpdBottomPanel);
    SetupTcpdBottomPanel();
  }

  private void SetupProfilePanel()
  {
    Panel TopPanel, BottomPanel;
    GridBagLayout GridBag;
    GridBagConstraints c;
    Label l;
    Insets RightInsets = new Insets(0,0,0,20);
    Insets LeftInsets = new Insets(0,20,0,0);
    Insets TopLeftInsets = new Insets(20,20,0,0);
    Insets TopRightInsets = new Insets(20,0,0,20);

    ServerProfilePanel.setLayout(new BorderLayout(5,5));
    TopPanel = new Panel();
    BottomPanel = new Panel();
    ServerProfilePanel.add("North", TopPanel);
    ServerProfilePanel.add("Center", BottomPanel);

  
    GridBag = new GridBagLayout();
    c = new GridBagConstraints();

    TopPanel.setLayout(GridBag);

    c.gridwidth = 1; c.gridheight = 1;
    c.fill = GridBagConstraints.NONE;
    c.weightx = 1.0; c.weighty = 1.0;


    c.gridx = 0; c.gridy = 0;
    c.anchor = GridBagConstraints.EAST;
    c.insets = TopLeftInsets;
    l = new Label("User List File");
    GridBag.setConstraints(l, c);
    TopPanel.add(l);

    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridx = 1; c.gridy = 0;
    c.insets = TopRightInsets;
    UserListFnameText = new TextField(20);
    GridBag.setConstraints(UserListFnameText, c);
    TopPanel.add(UserListFnameText);

    l = new Label("Log File Name");
    c.gridx = 0; c.gridy = 1;
    c.insets = LeftInsets;
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);


    c.gridx = 1; c.gridy = 1;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    LogFnameText = new TextField(20);
    GridBag.setConstraints(LogFnameText, c);
    TopPanel.add(LogFnameText);
   
    l = new Label("Local Host Name");
    c.gridx = 0; c.gridy = 2;
    c.fill = GridBagConstraints.NONE;
    c.insets = LeftInsets;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);

    c.gridx = 1; c.gridy = 2;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    HostNameText = new TextField(20);
    GridBag.setConstraints(HostNameText, c);
    TopPanel.add(HostNameText);


    l = new Label("Allowed Hosts File");
    c.gridx = 0; c.gridy = 3;
    c.fill = GridBagConstraints.NONE;
    c.insets = LeftInsets;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);


    c.gridx = 1; c.gridy = 3;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    TcpdFnameText = new TextField(20);
    GridBag.setConstraints(TcpdFnameText, c);
    TopPanel.add(TcpdFnameText);

    l = new Label("MailFactory class");
    c.gridx = 0; c.gridy = 4;
    c.fill = GridBagConstraints.NONE;
    c.insets = LeftInsets;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);

    c.gridx = 1; c.gridy = 4;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    MailFactoryText = new TextField(20);
    GridBag.setConstraints(MailFactoryText, c);
    TopPanel.add(MailFactoryText);

    l = new Label("Registered to");
    c.gridx = 0; c.gridy = 5;
    c.fill = GridBagConstraints.NONE;
    c.insets = LeftInsets;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);

    c.gridx = 1; c.gridy = 5;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    RegNameText = new TextField(20);
    GridBag.setConstraints(RegNameText, c);
    TopPanel.add(RegNameText);

    l = new Label("Registeration key");
    c.gridx = 0; c.gridy = 6;
    c.fill = GridBagConstraints.NONE;
    c.insets = LeftInsets;
    c.anchor = GridBagConstraints.EAST;
    GridBag.setConstraints(l, c);
    TopPanel.add(l);

    c.gridx = 1; c.gridy = 6;
    c.fill = GridBagConstraints.HORIZONTAL;
    c.insets = RightInsets;
    RegKeyText = new TextField(20);
    GridBag.setConstraints(RegKeyText, c);
    TopPanel.add(RegKeyText);

    c.gridx = 0; c.gridy = 7;
    c.fill = GridBagConstraints.NONE;
    c.anchor = GridBagConstraints.WEST;
    c.insets = TopLeftInsets;
    RestrictAccess = new Checkbox("Restrict Access");
    GridBag.setConstraints(RestrictAccess, c);
    TopPanel.add(RestrictAccess);


    c.gridx = 1; c.gridy = 7;
    c.fill = GridBagConstraints.NONE;
    c.insets = TopRightInsets;
    EnableLAST = new Checkbox("Enable LAST cmd");
    GridBag.setConstraints(EnableLAST, c);
    TopPanel.add(EnableLAST);

    c.gridx = 0; c.gridy = 8;
    c.insets = LeftInsets;
    c.fill = GridBagConstraints.HORIZONTAL;
    EnableUIDL = new Checkbox("Enable UIDL cmd");
    GridBag.setConstraints(EnableUIDL, c);
    TopPanel.add(EnableUIDL);

    c.gridx = 1; c.gridy = 8;
    c.fill = GridBagConstraints.NONE;
    c.insets = RightInsets;
    EnableTOP = new Checkbox("Enable TOP cmd");
    GridBag.setConstraints(EnableTOP, c);
    TopPanel.add(EnableTOP);

    c.gridx = 0; c.gridy = 9;
    c.insets = LeftInsets;
    c.fill = GridBagConstraints.HORIZONTAL;
    EnableAPOP = new Checkbox("Enable APOP cmd");
    GridBag.setConstraints(EnableAPOP, c);
    TopPanel.add(EnableAPOP);

    c.gridx = 1; c.gridy = 9;
    c.fill = GridBagConstraints.NONE;
    c.insets = RightInsets;
    EnableUSERPASS = new Checkbox("Enable USER|PASS");
    GridBag.setConstraints(EnableUSERPASS, c);
    TopPanel.add(EnableUSERPASS);

    BottomPanel.setLayout(new FlowLayout());
    ProfileApplyButton = new Button("Apply");
    BottomPanel.add(ProfileApplyButton);
  }


  private void LoadProfilePanel()
  {
    FileInputStream PropIn;

    ServerProps = new Properties();
    try
    {
      PropIn = new FileInputStream(PropFile);
      ServerProps.load(PropIn);
      PropIn.close();
    }
    catch (IOException e)
    {
    }

    UserListFnameText.setText(ServerProps.getProperty("rossi.Pop.UserList")); 
    RestrictAccess.setState(ServerProps.getProperty("rossi.Pop.UseTcpd").equals("true"));
    TcpdFnameText.setText(ServerProps.getProperty("rossi.Pop.TcpdConfig"));
    LogFnameText.setText(ServerProps.getProperty("rossi.Pop.LogFile"));
    HostNameText.setText(ServerProps.getProperty("rossi.Pop.HostName"));
    MailFactoryText.setText(ServerProps.getProperty("rossi.Pop.MailFactory"));
    RegNameText.setText(ServerProps.getProperty("rossi.Pop.RegName"));
    RegKeyText.setText(ServerProps.getProperty("rossi.Pop.RegKey"));
    EnableLAST.setState(ServerProps.getProperty("rossi.Pop.EnableLAST").equals("true"));
    EnableUIDL.setState(ServerProps.getProperty("rossi.Pop.EnableUIDL").equals("true"));
    EnableTOP.setState(ServerProps.getProperty("rossi.Pop.EnableTOP").equals("true"));
    EnableAPOP.setState(ServerProps.getProperty("rossi.Pop.EnableAPOP").equals("true"));
    EnableUSERPASS.setState(ServerProps.getProperty("rossi.Pop.EnableUSERPASS").equals("true"));
  }

  private void SetupMailFactoryPanel()
  {
    Panel BottomPanel;

    MailFactoryPanel.setLayout(new BorderLayout(5,5));
    MailFactoryOptionsTopPanel = new Panel();
    BottomPanel = new Panel();
    MailFactoryPanel.add("North", MailFactoryOptionsTopPanel);
    MailFactoryPanel.add("Center", BottomPanel);

    BottomPanel.setLayout(new FlowLayout());
    MailFactoryApplyButton = new Button("Apply");
    BottomPanel.add(MailFactoryApplyButton);
  }

  private void LoadMailFactoryPanel()
  {
    MailFactory m;
    String[] PropNames;
    Label[] Labels;
    int i, NumItems;
    Properties MailFactoryDefault;
    String str;

    m = newMailFactory();
    PropNames = m.listPropertyNames();
    NumItems = PropNames.length;
    MailFactoryDefault = m.getDefaultProperties();

    /* Remove anything from this panel that is there now */
    MailFactoryOptionsTopPanel.removeAll();

    MailFactoryOptionsTopPanel.setLayout(new GridLayout(NumItems*2, 1));

    MailFactoryOptionsText = new TextField[NumItems];
    Labels = new Label[NumItems];

    for (i=0; i<NumItems; i++)
    {
      Labels[i] = new Label(PropNames[i]);
      MailFactoryOptionsText[i] = new TextField();
      MailFactoryOptionsTopPanel.add(Labels[i]);
      MailFactoryOptionsTopPanel.add(MailFactoryOptionsText[i]);
      str = ServerProps.getProperty(PropNames[i]);
      if (str == null)
      {
        str = MailFactoryDefault.getProperty(PropNames[i]);
        if (str == null)
        {
           str = "";
        }
      } 
      MailFactoryOptionsText[i].setText(str);
    }
  }
 
  private void MailFactoryOptionsApply()
  {
    MailFactory m;
    String[] PropNames;
    Label[] Labels;
    int i, NumItems;
    Properties TestProps;
    String str;

    m = newMailFactory();
    PropNames = m.listPropertyNames();
    NumItems = PropNames.length;

    TestProps = new Properties();
    
    for (i=0; i<NumItems; i++)
      TestProps.put(PropNames[i], MailFactoryOptionsText[i].getText());

    m.setProperties(TestProps);
    str = m.checkProperties();
    if (str != null)
    {
      new SetupErrorDialog(this, str);
      return;
    }

    for (i=0; i<NumItems; i++)
      ServerProps.put(PropNames[i], TestProps.getProperty(PropNames[i]));

    ProfileChangesMade = true;
  }

  private boolean isMailFactoryValid()
  {
    Class c;
    Class Interfaces[];
    MailFactory m;
    boolean IsMailFactory = false;
    String MailFactoryName;
    int i;

    /* Scrutinize the MailFactory class name */

    MailFactoryName = MailFactoryText.getText();
    if (MailFactoryName == null || MailFactoryName.equals(""))
    {
      return false;
    }

    try
    {
      c = Class.forName(MailFactoryName);
    }
    catch (ClassNotFoundException e)
    {
      return false;
    }

    Interfaces = c.getInterfaces();
  
    for (i=0; i<Interfaces.length; i++)
    {
      if (Interfaces[i].getName().equals("rossi.Pop.MailFactory"))
        IsMailFactory = true;
    }

    if (IsMailFactory == false)
    {
      return false;
    }
    return true;
  }

  
  private MailFactory newMailFactory()
  {
    MailFactory m;
    Class c;

    try
    {
      c = Class.forName(MailFactoryText.getText());
    }
    catch (ClassNotFoundException e)
    {
      return null;
    }

    try
    {
      m = (MailFactory) c.newInstance();
    }
    catch (InstantiationException e)
    {
      return null;
    }
    catch (IllegalAccessException e)
    {
      return null;
    }

    return m;
  }

  private void setMailFactoryMenuItemState()
  {
    MailFactory m;
    String PropList;

    if (isMailFactoryValid() == false)
    {
      MailFactoryMenuItem.disable();
      return;
    }
 
    m = newMailFactory();
    if (m.listPropertyNames().length == 0)
    {
      MailFactoryMenuItem.disable();
      return;
    }
    
    MailFactoryMenuItem.enable();
  }

  private void ProfileApply()
  {
    File f;
    Class c;
    Class Interfaces[];
    MailFactory m;
    boolean IsMailFactory = false;
    String MailFactoryName;
    int i;


    /* Check out the parameters -- carefully */

    f = new File(UserListFnameText.getText());
    if (f.exists() == false)
    {
      /* try to write to it then */
      try
      {
        FileOutputStream fo = new FileOutputStream(f);
        fo.close();
      }
      catch (IOException e)
      {
        new SetupErrorDialog(this, "Invalid user list filename");
        return;
      }
    }
  
    if (f.isAbsolute() == false)
    {
      new SetupErrorDialog(this, "Must use fully qualified file names.");
      return;
    }

    if (RestrictAccess.getState() == true)
    {
      /* Check out the TCPD file */
      f = new File(TcpdFnameText.getText());
      if (f.exists() == false)
      {
	/* try to write to it then */
	try
	{
	  FileOutputStream fo = new FileOutputStream(f);
	  fo.close();
	}
	catch (IOException e)
	{
	  new SetupErrorDialog(this, "Invalid allowed hosts filename");
	  return;
	}
      }
      if (f.isAbsolute() == false)
      {
	new SetupErrorDialog(this, "Must use fully qualified file names.");
	return;
      }
    }

    f = new File(LogFnameText.getText());
    if (f.exists() == false)
    {
      /* try to write to it then */
      try
      {
        FileOutputStream fo = new FileOutputStream(f);
        fo.close();
      }
      catch (IOException e)
      {
        new SetupErrorDialog(this, "Invalid log filename");
        return;
      }
    }

    if (f.isAbsolute() == false)
    {
      new SetupErrorDialog(this, "Must use fully qualified file names.");
      return;
    }

    /* Scrutinize the MailFactory class name */

    MailFactoryName = MailFactoryText.getText();
    if (MailFactoryName == null || MailFactoryName.equals(""))
    {
      new SetupErrorDialog(this, "No MailFactory specified");
      return;
    }

    try
    {
      c = Class.forName(MailFactoryName);
    }
    catch (ClassNotFoundException e)
    {
      new SetupErrorDialog(this, "MailFactory "+MailFactoryName+" not found");
      return;
    }

    Interfaces = c.getInterfaces();
  
    for (i=0; i<Interfaces.length; i++)
    {
      if (Interfaces[i].getName().equals("rossi.Pop.MailFactory"))
        IsMailFactory = true;
    }

    if (IsMailFactory == false)
    {
      new SetupErrorDialog(this, "Class "+MailFactoryName+" is not a MailFactory");
      return;
    }

    ProfileChangesMade = true;
    ServerProps.put("rossi.Pop.UserList", UserListFnameText.getText()); 
    ServerProps.put("rossi.Pop.UseTcpd", 
                     new Boolean(RestrictAccess.getState()).toString());
    ServerProps.put("rossi.Pop.TcpdConfig", TcpdFnameText.getText());
    ServerProps.put("rossi.Pop.LogFile", LogFnameText.getText());
    ServerProps.put("rossi.Pop.HostName", HostNameText.getText());
    ServerProps.put("rossi.Pop.MailFactory", MailFactoryText.getText());
    ServerProps.put("rossi.Pop.RegName", RegNameText.getText());
    ServerProps.put("rossi.Pop.RegKey", RegKeyText.getText());
    ServerProps.put("rossi.Pop.EnableLAST", 
                     new Boolean(EnableLAST.getState()).toString());
    ServerProps.put("rossi.Pop.EnableUIDL", 
                     new Boolean(EnableUIDL.getState()).toString());
    ServerProps.put("rossi.Pop.EnableTOP", 
                     new Boolean(EnableTOP.getState()).toString());
    ServerProps.put("rossi.Pop.EnableAPOP", 
                     new Boolean(EnableAPOP.getState()).toString());
    ServerProps.put("rossi.Pop.EnableUSERPASS", 
                     new Boolean(EnableUSERPASS.getState()).toString());

    if (RestrictAccess.getState())
      TcpdMenuItem.enable();
    else
      TcpdMenuItem.disable();

    setMailFactoryMenuItemState();

    LoadUserList();
    LoadTcpdPanel();
  }

  private void SetupUserRightButtonPanel()
  {
    UserRightButtonPanel.setLayout(new GridLayout(3, 1, 20, 20));
    UserAddButton = new Button("Add");
    UserModifyButton = new Button("Modify");
    UserDeleteButton = new Button("Delete");
    UserRightButtonPanel.add(UserAddButton);
    UserRightButtonPanel.add(UserModifyButton);
    UserRightButtonPanel.add(UserDeleteButton);
  }

  private void SetupUserBottomPanel()
  {
    UserBottomPanel.setLayout(new GridLayout(3, 2, 5, 5));
    UserBottomPanel.add(new Label("Name"));
    UserNameText = new TextField();
    UserBottomPanel.add(UserNameText);
    UserBottomPanel.add(new Label("Password"));
    PasswordText = new TextField();
    PasswordText.setEchoCharacter('*');
    UserBottomPanel.add(PasswordText);
    UserBottomPanel.add(new Label("Mailbox Location"));
    MbxDirText = new TextField();
    UserBottomPanel.add(MbxDirText);
  }

  private void LoadUserList()
  {
    int i;
    UserSpec u = null;

    Config = new Configuration(ServerProps.getProperty("rossi.Pop.UserList"));
    UserList.delItems(0, UserList.countItems()-1);
    
    for (i=0; i<Config.UserList.size(); i++)
    {
      u = (UserSpec) Config.UserList.elementAt(i);
      UserList.addItem(u.Name);
    } 
  }

  private void SetupTcpdRightButtonPanel()
  {
    TcpdRightButtonPanel.setLayout(new GridLayout(3, 1, 20, 20));
    TcpdAddButton = new Button("Add");
    TcpdModifyButton = new Button("Modify");
    TcpdDeleteButton = new Button("Delete");
    TcpdRightButtonPanel.add(TcpdAddButton);
    TcpdRightButtonPanel.add(TcpdModifyButton);
    TcpdRightButtonPanel.add(TcpdDeleteButton);
  }

  private void SetupTcpdBottomPanel()
  {
    TcpdBottomPanel.setLayout(new GridLayout(3, 2, 5, 5));
    TcpdBottomPanel.add(new Label("Network"));
    TcpdNetworkText = new TextField();
    TcpdBottomPanel.add(TcpdNetworkText);
    TcpdBottomPanel.add(new Label("Net Mask"));
    TcpdNetMaskText = new TextField();
    TcpdBottomPanel.add(TcpdNetMaskText);
    TcpdBottomPanel.add(new Label("Comment"));
    TcpdCommentText = new TextField();
    TcpdBottomPanel.add(TcpdCommentText);
  }

  private void LoadTcpdPanel()
  {
    TcpdWrapper w;
    int i;

    w = new TcpdWrapper(ServerProps.getProperty("rossi.Pop.TcpdConfig"));
    TcpdAddr = w.Addr;
    TcpdMask = w.Mask;
    TcpdComment = w.Comment;

    TcpdList.delItems(0, TcpdList.countItems()-1);
    for (i=0; i<w.Addr.size(); i++)
    {
      TcpdList.addItem((String)(w.Comment.elementAt(i)));
    }
  }

  private boolean isInetAddr(String Address)
  {
    StringTokenizer st;
    int i, a;
    String s;

    /* Check out the arguments, make sure they are legit */
 
    st = new StringTokenizer(Address, ".");
    if (st.countTokens() == 4)
    {
      try
      {
        for (i=0; i<4; i++)
        {
          s = st.nextToken();
          a = Integer.parseInt(s);
          if (a < 0 || a > 255)
            return false;
        }
      }
      catch (NumberFormatException e)
      {
        return false;
      }
    }
    else
    {
      return  false;
    }
    return true;;
  }

  private void TcpdAddModify(boolean isAdd)
  {
    String Network, Mask, Comment;
    int i;

    /* Check out the arguments, make sure they are legit */
    if (isAdd == false)
    {
      i = TcpdList.getSelectedIndex();

      if (i == -1)
      {
        new SetupErrorDialog(this, "No network selected");
        return;
      }
    }
 
    Network = TcpdNetworkText.getText();
    if (isInetAddr(Network) == false)
    {
      new SetupErrorDialog(this, "Invalid network address.");
      return;
    }

    Mask = TcpdNetMaskText.getText();
    if (isInetAddr(Mask) == false)
    {
      new SetupErrorDialog(this, "Invalid Net Mask");
      return;
    }

    Comment = TcpdCommentText.getText();
    if (Comment.equals(""))
    {
      new SetupErrorDialog(this, "Must fill in a comment");
      return;
    }

    if (isAdd)
    {
      TcpdAddr.addElement(Network);
      TcpdMask.addElement(Mask);
      TcpdComment.addElement(Comment);
      TcpdList.addItem(Comment);
      TcpdNetworkText.setText("");
      TcpdNetMaskText.setText("");
      TcpdCommentText.setText("");
      ConfigChangesMade=true;
    }
    else
    {
      i = TcpdList.getSelectedIndex();

      if (i == -1)
      {
        new SetupErrorDialog(this, "No network selected");
        return;
      }

      TcpdAddr.setElementAt(Network, i);
      TcpdMask.setElementAt(Mask, i);
      TcpdComment.setElementAt(Comment, i);
      TcpdList.replaceItem(Comment, i);
      TcpdList.select(i);
      ConfigChangesMade=true;
    }
  }

  private void ModifyUserData(int action)
  {
    int Index;
    File MbxPath;
    UserSpec u = null;

    Index=UserList.getSelectedIndex();
    MbxPath = new File(MbxDirText.getText());

    if (Index == -1)
    {
      new SetupErrorDialog(this, "No user selected");
      return;
    }

    switch (action)
    {
      case 0:

        /* Check out the username */
        if (UserNameText.getText().equals(""))
        {
          new SetupErrorDialog(this, "Must have a user name");
          return;
        }

        /* Check out the password */
        if (PasswordText.getText().equals(""))
        {
          new SetupErrorDialog(this, "Must have a password");
          return;
        }

	/* check out the path */
        ModifyCreateDir = null;
	if (MbxPath.exists() == false)
        {
//          ModifyCreateDir = new SetupYesNoDialog(this, 
//               "Specified directory does not exist.  Create it?", false);
//          ModifyCreateDir.pack();
//          ModifyCreateDir.show(); 
//          return;
        }

      case 1:
     
        if (ModifyCreateDir != null && ModifyCreateDir.Answer) 
        { 
          if (MbxPath.mkdirs() == false)
          {
            new SetupErrorDialog(this, "Cannot create mailbox dir");
            return;
          }
        }
        
        u = (UserSpec) Config.UserList.elementAt(Index);
        u.Name = UserNameText.getText();
        u.Password = PasswordText.getText();
        u.Fname = MbxDirText.getText();
        UserList.replaceItem(u.Name, Index);
        UserList.select(Index);
        ConfigChangesMade = true;
    } 
  }

  private void AddUserData(int action)
  {
    int Index;
    File MbxPath;
    UserSpec u = null;
    String Uname;
    int i;

    MbxPath = new File(MbxDirText.getText());

    switch (action)
    {
      case 0:

        /* Check out the username */
        Uname = UserNameText.getText();
	for (i=0; i<Config.UserList.size(); i++)
	{
	  u = (UserSpec) Config.UserList.elementAt(i);
	  if (u.Name.equals(Uname))
          {
            new SetupErrorDialog(this, "User already exists");
            return;
          }
	} 

        if (Uname.equals(""))
        {
          new SetupErrorDialog(this, "Must have a user name");
          return;
        }

        /* Check out the password */
        if (PasswordText.getText().equals(""))
        {
          new SetupErrorDialog(this, "Must have a password");
          return;
        }

	/* check out the path */
        ModifyCreateDir = null;
	if (MbxPath.exists() == false)
        {
//          ModifyCreateDir = new SetupYesNoDialog(this, 
//               "Specified directory does not exist.  Create it?", false);
//          ModifyCreateDir.pack();
//          ModifyCreateDir.show(); 
//          return;
        }

      case 1:
     
        if (ModifyCreateDir != null && ModifyCreateDir.Answer) 
        { 
          if (MbxPath.mkdirs() == false)
          {
            new SetupErrorDialog(this, "Cannot create mailbox dir");
            return;
          }
        }
        
        u = new UserSpec();
        u.Name = UserNameText.getText();
        u.Password = PasswordText.getText();
        u.Fname = MbxDirText.getText();
        UserList.addItem(u.Name);
        Config.UserList.addElement(u);
        ConfigChangesMade = true;
        UserNameText.setText("");
        PasswordText.setText("");
        MbxDirText.setText("");
    } 
  }

  private void SaveChanges()
  {
    FileOutputStream fo;
    PrintStream pout;
    int i;
    UserSpec u = null;

    try
    {
      fo = new FileOutputStream(ServerProps.getProperty("rossi.Pop.UserList"));
      pout = new PrintStream(fo);

      for (i=0; i<Config.UserList.size(); i++)
      {
        u = (UserSpec) Config.UserList.elementAt(i);
        pout.println(u.Name+","+u.Password+","+u.Fname);
      } 
      fo.close();

      fo = new FileOutputStream(PropFile);
      ServerProps.save(fo, "");
      fo.close();

      fo = new FileOutputStream(ServerProps.getProperty("rossi.Pop.TcpdConfig"));
      pout = new PrintStream(fo);
      for (i=0; i<TcpdAddr.size(); i++)
        pout.println(TcpdAddr.elementAt(i)+" "+TcpdMask.elementAt(i)+" "+TcpdComment.elementAt(i));
   
      fo.close();

      ConfigChangesMade = false;
      ProfileChangesMade = false;
    }
    catch (IOException e)
    {
      new SetupErrorDialog(this, "IOException: "+e.getMessage());
      return;
    }
  }

  public boolean action(Event e, Object arg)
  {
    if (e.target == UserDeleteButton)
    {
      int i;
      i = UserList.getSelectedIndex();
      if (i != -1)
      {
	UserDeleteConfirm = new SetupYesNoDialog(this, 
			       "Delete User "+((UserSpec)(Config.UserList.elementAt(i))).Name+"?",
                                false);
        UserDeleteConfirm.pack();
        UserDeleteConfirm.show();
      }
      else
      {
        new SetupErrorDialog(this, "No user selected");
      }
      return true;
    }
  
    if (e.target == UserDeleteConfirm)
    {
      if (UserDeleteConfirm.Answer)
      {
        int i;
        i = UserList.getSelectedIndex();

	Config.UserList.removeElementAt(i);
	UserList.delItem(i);
	UserNameText.setText("");
	PasswordText.setText("");
	MbxDirText.setText("");
	ConfigChangesMade = true;
      }
      UserDeleteConfirm.hide();
      UserDeleteConfirm.dispose();
      UserDeleteConfirm.Disposed = true;
    }

    if (e.target == UserModifyButton)
    {
      ModifyUserData(0);
      return true;
    }

    if (e.target == UserAddButton)
    {
      AddUserData(0);
      return true;
    }

    if (e.target == ModifyCreateDir)
    {
      ModifyUserData(1);
      return true;
    }

    if (e.target == AddCreateDir)
    {
      AddUserData(1);
      return true;
    }

    if (e.target == TcpdDeleteButton)
    {
      int i;
      i = TcpdList.getSelectedIndex();
      if (i != -1)
      {
	NetworkDeleteConfirm = new SetupYesNoDialog(this, 
			       "Delete Network "+TcpdComment.elementAt(i)+"?",
                                false);
        NetworkDeleteConfirm.pack();
        NetworkDeleteConfirm.show();
      }
      else
      {
        new SetupErrorDialog(this, "No network selected");
      }
      return true;
    }

    if (e.target == NetworkDeleteConfirm)
    {
      if (NetworkDeleteConfirm.Answer)
      {
        int i;
        i = TcpdList.getSelectedIndex();
 
	TcpdAddr.removeElementAt(i);
	TcpdMask.removeElementAt(i);
	TcpdComment.removeElementAt(i);

	TcpdList.delItem(i);
	TcpdNetworkText.setText("");
	TcpdNetMaskText.setText("");
	TcpdCommentText.setText("");
	ConfigChangesMade = true;
      }
      NetworkDeleteConfirm.hide();
      NetworkDeleteConfirm.dispose();
      NetworkDeleteConfirm.Disposed = true;
    }

    if (e.target == TcpdAddButton)
    {
      TcpdAddModify(true);
      return true;
    }

    if (e.target == TcpdModifyButton)
    {
      TcpdAddModify(false);
      return true;
    }

    if (e.target == SaveMenuItem)
    {
      SaveChanges();
      return true;
    }

    if (e.target == SaveChangesYesNo)
    {
      if (SaveChangesYesNo.Answer)
        SaveChanges();
      SaveChangesYesNo.hide();
      SaveChangesYesNo.dispose();
      SaveChangesYesNo.Disposed = true;
      if (SaveChangesYesNo.Canceled == false)
      {
        hide();
        dispose();
        System.exit(0);
      }
    }

    if (e.target == SaveBeforeSwitch)
    {
      SaveBeforeSwitch.hide();
      SaveBeforeSwitch.dispose();
      SaveBeforeSwitch.Disposed = true;

      if (SaveBeforeSwitch.Canceled == true)
        return true;

      if (SaveBeforeSwitch.Answer)
      {
        SaveChanges();
      }
      else
      {
        /* If they said 'No', then reinitialize everything */

	LoadProfilePanel();
	LoadUserList();
	LoadTcpdPanel();
        UserNameText.setText("");
        PasswordText.setText("");
        MbxDirText.setText("");
	TcpdNetworkText.setText("");
	TcpdNetMaskText.setText("");
	TcpdCommentText.setText("");
	ConfigChangesMade = false;
	ProfileChangesMade = false;
      }

      if (NextPanel.equals("MailFactory"))
        LoadMailFactoryPanel();

      Cards.show(this, NextPanel);

      if (NextPanel.equals("User"))
        UserList.requestFocus();
    }

    if (e.target == UsersMenuItem)
    {
//      System.err.println("Selected user panel");

      if (ConfigChangesMade || ProfileChangesMade)
      {
        NextPanel = "User";
	SaveBeforeSwitch = new SetupYesNoDialog(this, 
			       "Save Changes?", true);
	SaveBeforeSwitch.pack();
	SaveBeforeSwitch.show();
      }
      else
      {
        Cards.show(this, "User");
        UserList.requestFocus();
      }
      return true;
    }

    if (e.target == ProfileMenuItem)
    {
//      System.err.println("Selected profile panel");

      if (ConfigChangesMade || ProfileChangesMade)
      {
        NextPanel = "Profile";
	SaveBeforeSwitch = new SetupYesNoDialog(this, 
			       "Save Changes?", true);
	SaveBeforeSwitch.pack();
	SaveBeforeSwitch.show();
      }
      else
      {
        Cards.show(this, "Profile");
      }

      return true;
    }

    if (e.target == TcpdMenuItem)
    {
//      System.err.println("Selected Tcpd panel");

      if (ConfigChangesMade || ProfileChangesMade)
      {
        NextPanel = "Tcpd";
	SaveBeforeSwitch = new SetupYesNoDialog(this, 
			       "Save Changes?", true);
	SaveBeforeSwitch.pack();
	SaveBeforeSwitch.show();
      }
      else
      {
        Cards.show(this, "Tcpd");
      }

      return true;
    }

    if (e.target == MailFactoryMenuItem)
    {
//      System.err.println("Selected MailFactory panel");

      if (ConfigChangesMade || ProfileChangesMade)
      {
        NextPanel = "MailFactory";
	SaveBeforeSwitch = new SetupYesNoDialog(this, 
			       "Save Changes?", true);
	SaveBeforeSwitch.pack();
	SaveBeforeSwitch.show();
      }
      else
      {
        LoadMailFactoryPanel();
        Cards.show(this, "MailFactory");
      }

      return true;
    }

    if (e.target == ProfileApplyButton)
    {
      ProfileApply();
      return true;
    }

    if (e.target == MailFactoryApplyButton)
    {
      MailFactoryOptionsApply();
      return true;
    }

    if (e.target == AboutMenuItem)
    {
      AboutBox = new SetupAboutBox(this);
      return true;
    }

    return false;
  }

  public void show()
  {
    if (AboutBox != null && AboutBox.Disposed == false)
    {
      AboutBox.show();
      return;
    }

    if (AddCreateDir != null && AddCreateDir.Disposed == false)
    {
      AddCreateDir.show();
      return;
    }

    if (ModifyCreateDir != null && ModifyCreateDir.Disposed == false)
    {
      ModifyCreateDir.show();
      return;
    }

    if (SaveChangesYesNo != null && SaveChangesYesNo.Disposed == false)
    {
      SaveChangesYesNo.show();
      return;
    }

    if (SaveBeforeSwitch != null && SaveBeforeSwitch.Disposed == false)
    {
      SaveBeforeSwitch.show();
      return;
    }

    if (UserDeleteConfirm != null && UserDeleteConfirm.Disposed == false)
    {
      UserDeleteConfirm.show();
      return;
    }

    if (NetworkDeleteConfirm != null && NetworkDeleteConfirm.Disposed == false)
    {
      NetworkDeleteConfirm.show();
      return;
    }

    if (AboutBox != null && AboutBox.Disposed == false)
    {
      AboutBox.requestFocus();
      return;
    }
    super.show();
  }

  public boolean handleEvent(Event e)
  { 
    if (e.id == Event.KEY_RELEASE && e.key==9)
    {
      if (e.target instanceof Component)
      {
        if (e.target == MbxDirText)
          UserList.requestFocus();
        else 
          ((Component)(e.target)).nextFocus();
      }
      else
      {
        UserList.requestFocus();
      }
      return true;
    }

    if (e.id == Event.WINDOW_DESTROY || e.target==ExitMenuItem)
    {
      if (ConfigChangesMade == false && ProfileChangesMade == false)
      {
        hide();
        dispose();
        System.exit(0);
      }
      else
      {
        SaveChangesYesNo = new SetupYesNoDialog(this, 
                             "Save Changes?", true);
        SaveChangesYesNo.pack();
        SaveChangesYesNo.show();
        return true;
      }
    }

    if (e.target == UserList && e.id == Event.LIST_SELECT)
    {
      int i;
      UserSpec u = null;

      i = UserList.getSelectedIndex();
      if (i != -1)
      {
        u = (UserSpec) Config.UserList.elementAt(i);
        UserNameText.setText(u.Name);
        PasswordText.setText(u.Password);
        MbxDirText.setText(u.Fname);
      }
      return true;
    }

    if (e.target == TcpdList && e.id == Event.LIST_SELECT)
    {
      int i;

      i = TcpdList.getSelectedIndex();
      if (i != -1)
      {
        TcpdNetworkText.setText((String)(TcpdAddr.elementAt(i)));
        TcpdNetMaskText.setText((String)(TcpdMask.elementAt(i)));
        TcpdCommentText.setText((String)(TcpdComment.elementAt(i)));
      }
      return true;
    }

    return super.handleEvent(e);
  }

  public static void main(String args[])
  {
    System.err.println("J-POP  (C) 1997 Rossi Engineering, All rights reserverd");
    new Setup();
  }
}
