
package rossi.Pop;

import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class TcpdWrapper
{
  protected Vector Addr, Mask, Comment;

  public TcpdWrapper(String ConfigFname)
  {
    FileInputStream f;
    DataInputStream din;
    StringTokenizer st;
    String Line = null;

    Addr = new Vector();
    Mask = new Vector();
    Comment = new Vector();
 
    try
    {
      f = new FileInputStream(ConfigFname);
      din = new DataInputStream(f);

      while (true)
      {
        Line = din.readLine();
        if (Line == null)
          break;
 
        st = new StringTokenizer(Line, " ");
        if (st.countTokens() > 1)
        {
          String s;

          Addr.addElement(st.nextToken());
          Mask.addElement(st.nextToken());
          s = st.nextToken();
          if (st.hasMoreTokens())
            s = s+" "+st.nextToken("");
          Comment.addElement(s);
        }
      }

      f.close();
    }
    catch (IOException e)
    {
    }
  }

  private byte[] parseAddr(String addr)
  {
    StringTokenizer st = new StringTokenizer(addr, ".");
    byte[] a = new byte[4]; 
    int i;   
  
    for (i=0; i<4; i++)
    {
      try
      {
        a[i] = (byte) (Integer.parseInt(st.nextToken()));
      }
      catch (NumberFormatException e)
      {
      }
    }
    return a;
  }

  public boolean CheckAuth(InetAddress iaddr)
  {
    byte[] iaddrbytes, addr, mask;
    int i, j;
  
    iaddrbytes = iaddr.getAddress();

    for (i=0; i<Addr.size(); i++)
    {
      addr = parseAddr((String)(Addr.elementAt(i)));
      mask = parseAddr((String)(Mask.elementAt(i)));
    
      for (j=0; j<4; j++)
      {
        if ((addr[j] & mask[j]) != (iaddrbytes[j] & mask[j]))
          break;
      }
      if (j==4)
        return true;
    }
    return false;
  }
}
